%%% SMT covariance matrix estimate %%%%%
function [T,lambda,SMTArray]=SMTCovarEst(Y,K)

[N,M]=size(Y);

if nargin == 1
   index=randperm(M);
   Y=Y(:,index);
   M1=ceil(M*1/3);

   NumRotations = ceil(log2(M)*N/2);

   Rhat = Y(:,1:2*M1)*Y(:,1:2*M1)'/(2*M1);
   [T,SMTArray,likelihood1] = ComputeSMT(Rhat,NumRotations,Y(:,2*M1+1:M));

   Y=circshift(Y,[0,M-2*M1]);
   Rhat = Y(:,1:2*M1)*Y(:,1:2*M1)'/(2*M1);
   [T,SMTArray,likelihood2] = ComputeSMT(Rhat,NumRotations,Y(:,2*M1+1:M));

   Y=circshift(Y,[0,M-2*M1]);
   Rhat = Y(:,1:2*M1)*Y(:,1:2*M1)'/(2*M1);
   [T,SMTArray,likelihood3] = ComputeSMT(Rhat,NumRotations,Y(:,2*M1+1:M));

   likelihood=likelihood1+likelihood2+likelihood3;
   [valmax,K]=max(likelihood);
   %figure,plot(likelihood)
   %xlabel('# of SMT rotations')
   %ylabel('log-likelihood')
   if K==NumRotations
       disp('It may require more rotations!');
   end
end

K

Rhat = (1/M)*Y*Y';
[T,SMTArray,likelihood] = ComputeSMT(Rhat,K);

[lambda,I] = sort(diag(T'*Rhat*T),'descend');  %%% this line can be fast implemented!!
T=T(:,I);
lambda=diag(lambda);

