%%% SMT Shrinkage Estimator %%%%%
function [E,Lambda]=SMTShrk(Y,alpha)

[N,M]=size(Y);

[ESMT,lambdaSMT,SMTArray] = SMTCovarEst(Y);
RSMT=ESMT*lambdaSMT*ESMT';

if nargin == 3
     alpha_opt=alpha;
else
     [ESMT,LambdaSMT]=eig(RSMT);
     YSMT=ESMT'*Y;
     S=YSMT*YSMT'/M;;
     alpha=0.1:0.1:1;
     for i=1:size(alpha,2)
           alpha1=alpha(i);
           alpha2=1-alpha1;
           G=alpha1*LambdaSMT+alpha2*(M)/(M-1)*S;
           k=alpha2/(M-1);
           [E,Lambda]=eig(G);
           Ginv=E*diag((1./diag(Lambda)))*E';
           logGdet=sum(log(diag(Lambda)));
           log_likelihood=zeros(M,1);
           for m=1:M
                d=YSMT(:,m)'*Ginv*YSMT(:,m);
                log_likelihood(m)=-M/2*log(2*pi)-1/2*logGdet-1/2*log(1-k*d)-1/2*(d/(1-k*d));
            end
            avg_LOOL(i)=sum(log_likelihood)/M;
     end
     avg_LOOL;
     
     [val_max,i_max]=max(avg_LOOL);
     alpha_opt=alpha(i_max)
end
     
S=Y*Y'/M;
RSMTshrk=(1-alpha_opt)*S+alpha_opt*RSMT;

[E,Lambda] = eig(RSMTshrk);
[Lambda,I] = sort(diag(Lambda),'descend');
E=E(:,I);
Lambda=diag(Lambda);

